// file test_if_assertions.sv
interface bus_if(input logic clk);
//  signal declarations
	bit abc, a, b, c;
	// demo
	function void f(logic v);
		abc               =v; 
	endfunction : f
	apabc : assert property (@ (posedge clk)
		$rose(a) |=> (b, f(1'b1) ) ##[1:10] c);
endinterface

interface b_if (input logic clk);   
	logic a, b, ab_error;
	clocking cb @ (posedge clk); endclocking
	int count; // Value may have been set from a class 
	// If $rose(a), then b==0 for count cycles, count >= 1. 
	// This is then followed by b==1 within 5 cycles after that.
	property p_ab_min; 
		int count_v; 
		($rose(a), count_v=count) |=> (!b, count_v-=1'b1)[* 1:$] ##1 count_v==0 ##[1:5] b;
	endproperty : p_ab_min
	ap_ab_min: assert property(@ (posedge clk) p_ab_min) 
		ab_error                               <= 1'b0; else ab_error <= 1'b1;  
endinterface : b_if

class tc;
	virtual interface b_if vif;
	task doit(int size, logic aa); 
		vif.count         =size; 
		vif.a             =aa;
		vif.b             =1'b0;
		repeat(6) @ this.vif.cb; 
		vif.b             =1'b1;
	endtask : doit
endclass : tc

module top; 
	logic clk=0; 
	b_if b_if1(clk); 
	tc tc1   =new(); 
	initial forever #10 clk=!clk; 
	initial begin 
		tc1.vif           = b_if1; // connect the virtual interface 
		tc1.doit(3, 1); 
		repeat(10) @ b_if1.cb; 
		tc1.doit(1, 0); 
		repeat(10) @ b_if1.cb; 
		tc1.doit(6, 1); 
	end
endmodule

module test; 
	logic clk=0; 
	b_if b_if1(clk); 
	initial forever #10 clk=!clk; 
	initial begin
		b_if1.count       =3; 
		b_if1.a           =1'b1;
		b_if1.b           =1'b0;
		repeat(6) @ (posedge clk); 

		b_if1.b           =1'b1;
	end
endmodule

